<?php

/* Setting the error reporting level */
error_reporting(E_ALL ^ E_NOTICE);
include 'connect.php';

if(!$_GET['url'] || !filter_input(INPUT_GET,'url',FILTER_VALIDATE_URL)){
	exit;
}

$pageID			= 0;
$appreciated	= 0;
$jsonArray		= array();
$hash			= md5($_GET['url']);
$ip				= sprintf('%u',ip2long($_SERVER['REMOTE_ADDR']));


$result = $mysqli->query("SELECT id,appreciated FROM appreciate_pages WHERE hash='".$hash."'");

if($result)
{
	list($pageID,$appreciated) = $result->fetch_row();	
}

// The submit parameter denotes that we need to write to the database

if($_GET['submit'])
{
	if(!$pageID)
	{	
		// If the page has not been appreciated yet, insert a new
		// record to the database.
	
		$mysqli->query("
			INSERT INTO appreciate_pages
			SET
				hash='".$hash."',
				url='".$mysqli->real_escape_string($_GET['url'])."'"
		);
		
		if($mysqli->affected_rows){

			// The insert_id property contains the value of
			// the primary key. In our case this is also the pageID.
			
			$pageID = $mysqli->insert_id;
		}
	}

	// Write the vote to the DB, so the user can vote only once
	
	$mysqli->query("
		INSERT INTO appreciate_votes
		SET
			ip = ".$ip.",
			pageid = ".$pageID
	);
	
	if($mysqli->affected_rows){
		$mysqli->query("UPDATE appreciate_pages SET appreciated=appreciated+1 WHERE id=".$pageID);
		
		// Increment the appreciated field
	}
	
	$jsonArray = array('status'=>1);
}
else
{
	// Only print the stats
	
	$voted = 0;
	
	// Has the user voted?
	$res = $mysqli->query("SELECT 1 FROM appreciate_votes WHERE ip=".$ip." AND pageid='".$pageID."'");
	
	if($res->num_rows){
		$voted = 1;
	}
	
	$jsonArray = array('status'=>1,'voted'=>$voted,'appreciated'=>$appreciated);
}

// Telling the browser to interpret the response as JSON:
header('Content-type: application/json');

echo json_encode($jsonArray);

?>